diff --git a/src/backend/parser/gram.y b/src/backend/parser/gram.y
index 4aa8646..28591c9 100644
--- a/src/backend/parser/gram.y
+++ b/src/backend/parser/gram.y
@@ -425,7 +425,7 @@ static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);
 				OptTableElementList TableElementList OptInherit definition
 				OptTypedTableElementList TypedTableElementList
 				reloptions opt_reloptions
-				OptWith opt_definition func_args func_args_list
+				OptWith opt_definition opt_resolver_definition func_args func_args_list
 				func_args_with_defaults func_args_with_defaults_list
 				aggr_args aggr_args_list
 				func_as createfunc_opt_list opt_createfunc_opt_list alterfunc_opt_list
@@ -613,6 +613,7 @@ static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);
 %type <ival>	opt_check_option
 
 %type <str>		opt_provider security_label
+%type <str>		conflict_type
 
 %type <target>	xml_attribute_el
 %type <list>	xml_attribute_list xml_attributes
@@ -770,7 +771,7 @@ static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);
 
 	RANGE READ REAL REASSIGN RECURSIVE REF_P REFERENCES REFERENCING
 	REFRESH REINDEX RELATIVE_P RELEASE RENAME REPEATABLE REPLACE REPLICA
-	RESET RESTART RESTRICT RETURN RETURNING RETURNS REVOKE RIGHT ROLE ROLLBACK ROLLUP
+	RESET RESOLVER RESTART RESTRICT RETURN RETURNING RETURNS REVOKE RIGHT ROLE ROLLBACK ROLLUP
 	ROUTINE ROUTINES ROW ROWS RULE
 
 	SAVEPOINT SCALAR SCHEMA SCHEMAS SCROLL SEARCH SECOND_P SECURITY SELECT
@@ -8813,6 +8814,11 @@ opt_definition:
 			| /*EMPTY*/								{ $$ = NIL; }
 		;
 
+opt_resolver_definition:
+			CONFLICT RESOLVER definition			{ $$ = $3; }
+			| /*EMPTY*/								{ $$ = NIL; }
+		;
+
 table_func_column:	param_name func_type
 				{
 					FunctionParameter *n = makeNode(FunctionParameter);
@@ -10747,14 +10753,15 @@ AlterPublicationStmt:
  *****************************************************************************/
 
 CreateSubscriptionStmt:
-			CREATE SUBSCRIPTION name CONNECTION Sconst PUBLICATION name_list opt_definition
+	CREATE SUBSCRIPTION name CONNECTION Sconst PUBLICATION name_list opt_resolver_definition opt_definition
 				{
 					CreateSubscriptionStmt *n =
 						makeNode(CreateSubscriptionStmt);
 					n->subname = $3;
 					n->conninfo = $5;
 					n->publication = $7;
-					n->options = $8;
+					n->resolvers = $8;
+					n->options = $9;
 					$$ = (Node *) n;
 				}
 		;
@@ -10861,6 +10868,38 @@ AlterSubscriptionStmt:
 					n->options = $5;
 					$$ = (Node *) n;
 				}
+			| ALTER SUBSCRIPTION name opt_resolver_definition
+				{
+					AlterSubscriptionStmt *n =
+						makeNode(AlterSubscriptionStmt);
+
+					n->kind = ALTER_SUBSCRIPTION_CONFLICT_RESOLVERS;
+					n->subname = $3;
+					n->resolvers = $4;
+					$$ = (Node *) n;
+				}
+			| ALTER SUBSCRIPTION name RESET CONFLICT RESOLVER ALL
+				{
+					AlterSubscriptionStmt *n =
+						makeNode(AlterSubscriptionStmt);
+
+					n->kind = ALTER_SUBSCRIPTION_CONFLICT_RESOLVER_RESET_ALL;
+					n->subname = $3;
+					$$ = (Node *) n;
+				}
+			| ALTER SUBSCRIPTION name RESET CONFLICT RESOLVER FOR conflict_type
+				{
+					AlterSubscriptionStmt *n =
+						makeNode(AlterSubscriptionStmt);
+
+					n->kind = ALTER_SUBSCRIPTION_CONFLICT_RESOLVER_RESET;
+					n->subname = $3;
+					n->conflict_type_name = $8;
+					$$ = (Node *) n;
+				}
+		;
+conflict_type:
+			Sconst								{ $$ = $1; }
 		;
 
 /*****************************************************************************
@@ -17785,6 +17824,7 @@ unreserved_keyword:
 			| REPLACE
 			| REPLICA
 			| RESET
+			| RESOLVER
 			| RESTART
 			| RESTRICT
 			| RETURN
@@ -18414,6 +18454,7 @@ bare_label_keyword:
 			| REPLACE
 			| REPLICA
 			| RESET
+			| RESOLVER
 			| RESTART
 			| RESTRICT
 			| RETURN
diff --git a/src/backend/replication/logical/conflict.c b/src/backend/replication/logical/conflict.c
index 5d9ff62..cb6d50c 100644
--- a/src/backend/replication/logical/conflict.c
+++ b/src/backend/replication/logical/conflict.c
@@ -8,30 +8,111 @@
  *	  src/backend/replication/logical/conflict.c
  *
  * This file contains the code for logging conflicts on the subscriber during
- * logical replication.
+ * logical replication and setting up conflict resolvers for a subscription.
  *-------------------------------------------------------------------------
  */
 
 #include "postgres.h"
 
 #include "access/commit_ts.h"
+#include "access/heapam.h"
+#include "catalog/indexing.h"
+#include "catalog/pg_subscription_conflict_d.h"
+#include "commands/defrem.h"
 #include "access/tableam.h"
 #include "executor/executor.h"
+#include "parser/scansup.h"
 #include "pgstat.h"
 #include "replication/conflict.h"
+#include "utils/builtins.h"
+#include "utils/fmgroids.h"
 #include "replication/worker_internal.h"
 #include "storage/lmgr.h"
 #include "utils/lsyscache.h"
+#include "utils/syscache.h"
+
+static const char *const ConflictResolverNames[] = {
+	[CR_APPLY_REMOTE] = "apply_remote",
+	[CR_KEEP_LOCAL] = "keep_local",
+	[CR_APPLY_OR_SKIP] = "apply_or_skip",
+	[CR_APPLY_OR_ERROR] = "apply_or_error",
+	[CR_SKIP] = "skip",
+	[CR_ERROR] = "error"
+};
+
+StaticAssertDecl(lengthof(ConflictResolverNames) == CONFLICT_NUM_RESOLVERS,
+				 "array length mismatch");
 
-static const char *const ConflictTypeNames[] = {
-	[CT_INSERT_EXISTS] = "insert_exists",
-	[CT_UPDATE_ORIGIN_DIFFERS] = "update_origin_differs",
-	[CT_UPDATE_EXISTS] = "update_exists",
-	[CT_UPDATE_MISSING] = "update_missing",
-	[CT_DELETE_ORIGIN_DIFFERS] = "delete_origin_differs",
-	[CT_DELETE_MISSING] = "delete_missing"
+/*
+ * Valid conflict resolvers for each conflict type.
+ *
+ * First member represents default resolver for each conflict_type.
+ * The same defaults are used in pg_dump.c. If any default is changed here,
+ * ensure the corresponding value is updated in pg_dump's is_default_resolver
+ * function.
+ *
+ * XXX: If we do not want to maintain different resolvers such as
+ * apply_or_skip and apply_or_error for update_missing conflict,
+ * then we can retain apply_remote and keep_local only. Then these
+ * resolvers in context of update_missing will mean:
+ *
+ * keep_local: do not apply the update as INSERT.
+ * apply_remote: apply the update as INSERT. If we could not apply,
+ * then log and skip.
+ *
+ * Similarly SKIP can be replaced with KEEP_LOCAL for both update_missing
+ * and delete_missing conflicts. For missing rows, 'SKIP' sounds more user
+ * friendly name for a resolver and thus has been added here.
+ */
+typedef struct ConflictInfo {
+		ConflictType conflict_type;
+		const char *conflict_name;
+		ConflictResolver default_resolver;
+		bool allowed_resolvers[CONFLICT_NUM_RESOLVERS];
+} ConflictInfo;
+
+static ConflictInfo ConflictInfoMap[] = {
+	[CT_INSERT_EXISTS] = {
+		.conflict_type = CT_INSERT_EXISTS,
+		.conflict_name = "insert_exists",
+		.default_resolver = CR_ERROR,
+		.allowed_resolvers = {[CR_ERROR]=true, [CR_APPLY_REMOTE]=true, [CR_KEEP_LOCAL]=true},
+	},
+	[CT_UPDATE_EXISTS] = {
+		.conflict_type = CT_UPDATE_EXISTS,
+		.conflict_name = "update_exists",
+		.default_resolver = CR_ERROR,
+		.allowed_resolvers = {[CR_ERROR]=true, [CR_APPLY_REMOTE]=true, [CR_KEEP_LOCAL]=true},
+	},
+	[CT_UPDATE_ORIGIN_DIFFERS] = {
+		.conflict_type = CT_UPDATE_ORIGIN_DIFFERS,
+		.conflict_name = "update_origin_differs",
+		.default_resolver = CR_APPLY_REMOTE,
+		.allowed_resolvers = {[CR_APPLY_REMOTE]=true, [CR_KEEP_LOCAL]=true, [CR_ERROR]=true},
+	},
+	[CT_UPDATE_MISSING] = {
+		.conflict_type = CT_UPDATE_MISSING,
+		.conflict_name = "update_missing",
+		.default_resolver = CR_SKIP,
+		.allowed_resolvers = {[CR_SKIP]=true, [CR_APPLY_OR_SKIP]=true, [CR_APPLY_OR_ERROR]=true, [CR_ERROR]=true},
+	},
+	[CT_DELETE_MISSING] = {
+		.conflict_type = CT_DELETE_MISSING,
+		.conflict_name = "delete_missing",
+		.default_resolver = CR_SKIP,
+		.allowed_resolvers = {[CR_SKIP]=true, [CR_ERROR]=true},
+	},
+	[CT_DELETE_ORIGIN_DIFFERS] = {
+		.conflict_type = CT_DELETE_ORIGIN_DIFFERS,
+		.conflict_name = "delete_origin_differs",
+		.default_resolver = CR_APPLY_REMOTE,
+		.allowed_resolvers = {[CR_APPLY_REMOTE]=true, [CR_KEEP_LOCAL]=true, [CR_ERROR]=true},
+	},
 };
 
+StaticAssertDecl(lengthof(ConflictInfoMap) == CONFLICT_NUM_TYPES,
+				 "array length mismatch");
+
 static int	errcode_apply_conflict(ConflictType type);
 static int	errdetail_apply_conflict(EState *estate,
 									 ResultRelInfo *relinfo,
@@ -122,7 +203,7 @@ ReportApplyConflict(EState *estate, ResultRelInfo *relinfo, int elevel,
 			errmsg("conflict detected on relation \"%s.%s\": conflict=%s",
 				   get_namespace_name(RelationGetNamespace(localrel)),
 				   RelationGetRelationName(localrel),
-				   ConflictTypeNames[type]),
+				   ConflictInfoMap[type].conflict_name),
 			errdetail_apply_conflict(estate, relinfo, type, searchslot,
 									 localslot, remoteslot, indexoid,
 									 localxmin, localorigin, localts));
@@ -489,3 +570,355 @@ build_index_value_desc(EState *estate, Relation localrel, TupleTableSlot *slot,
 
 	return index_value;
 }
+
+/*
+ * Report a warning about incomplete conflict detection and resolution if
+ * track_commit_timestamp is disabled.
+ */
+static void
+conf_detection_check_prerequisites(void)
+{
+	if (!track_commit_timestamp)
+		ereport(WARNING,
+				errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+				errmsg("conflict detection and resolution could be incomplete due to disabled track_commit_timestamp"),
+				errdetail("Conflict types 'update_origin_differs' and 'delete_origin_differs'"
+						  "cannot be detected unless 'track_commit_timestamp' is enabled"));
+}
+
+/*
+ * Validate the conflict type and return the corresponding ConflictType enum.
+ */
+ConflictType
+ValidateConflictType(const char *conflict_type)
+{
+	ConflictType type;
+	bool		valid = false;
+
+	/* Check conflict type validity */
+	for (type = 0; type < CONFLICT_NUM_TYPES; type++)
+	{
+		if (pg_strcasecmp(ConflictInfoMap[type].conflict_name, conflict_type) == 0)
+		{
+			valid = true;
+			break;
+		}
+	}
+
+	if (!valid)
+		ereport(ERROR,
+				errcode(ERRCODE_INVALID_PARAMETER_VALUE),
+				errmsg("%s is not a valid conflict type", conflict_type));
+
+	return type;
+}
+
+/*
+ * Validate the conflict type and resolver. It returns an enum ConflictType
+ * corresponding to the conflict type string passed by the caller.
+ */
+ConflictType
+ValidateConflictTypeAndResolver(const char *conflict_type,
+								const char *conflict_resolver)
+{
+	ConflictType type;
+	ConflictResolver resolver;
+	bool		valid = false;
+
+	/* Validate conflict type */
+	type = ValidateConflictType(conflict_type);
+
+	/* Validate the conflict resolver name */
+	for (resolver = 0; resolver < CONFLICT_NUM_RESOLVERS; resolver++)
+	{
+		if (pg_strcasecmp(ConflictResolverNames[resolver], conflict_resolver) == 0)
+		{
+			valid = true;
+			break;
+		}
+	}
+
+	if (!valid)
+	{
+		ereport(ERROR,
+				errcode(ERRCODE_INVALID_PARAMETER_VALUE),
+				errmsg("%s is not a valid conflict resolver", conflict_resolver));
+	}
+
+	valid = ConflictInfoMap[type].allowed_resolvers[resolver];
+
+	if (!valid)
+		ereport(ERROR,
+				errcode(ERRCODE_INVALID_PARAMETER_VALUE),
+				errmsg("%s is not a valid conflict resolver for conflict type %s",
+					   conflict_resolver,
+					   conflict_type));
+
+	return type;
+}
+
+/*
+ * Common 'CONFLICT RESOLVER' parsing function for CREATE and ALTER
+ * SUBSCRIPTION commands.
+ *
+ * It reports an error if duplicate options are specified.
+ *
+ * Returns a list of conflict types along with their corresponding conflict
+ * resolvers. If 'add_defaults' is true, it appends default resolvers for any
+ * conflict types that have not been explicitly defined by the user.
+ */
+List *
+ParseAndGetSubConflictResolvers(ParseState *pstate,
+								List *stmtresolvers, bool add_defaults)
+{
+	List		   *res = NIL;
+	bool			already_seen[CONFLICT_NUM_TYPES] = {0};
+	ConflictType 	type;
+
+	/* Loop through the user provided resolvers */
+	foreach_ptr(DefElem, defel, stmtresolvers)
+	{
+		char	   *resolver;
+		ConflictTypeResolver *conftyperesolver = NULL;
+
+		/* Validate the conflict type and resolver */
+		resolver = defGetString(defel);
+		resolver = downcase_truncate_identifier(
+												resolver, strlen(resolver), false);
+		type = ValidateConflictTypeAndResolver(defel->defname,
+											   resolver);
+
+		/* Check if the conflict type has already been seen */
+		if (already_seen[type])
+			errorConflictingDefElem(defel, pstate);
+
+		already_seen[type] = true;
+
+		conftyperesolver = palloc(sizeof(ConflictTypeResolver));
+		conftyperesolver->conflict_type_name = defel->defname;
+		conftyperesolver->conflict_resolver_name = resolver;
+		res = lappend(res, conftyperesolver);
+	}
+
+	/* Once validation is complete, warn users if prerequisites are not met */
+	if (stmtresolvers)
+		conf_detection_check_prerequisites();
+
+	/*
+	 * If add_defaults is true, fill remaining conflict types with default
+	 * resolvers.
+	 */
+	if (add_defaults)
+	{
+		for (int i = 0; i < CONFLICT_NUM_TYPES; i++)
+		{
+			ConflictTypeResolver *conftyperesolver = NULL;
+
+			if (!already_seen[i])
+			{
+				ConflictResolver def_resolver = ConflictInfoMap[i].default_resolver;
+
+				conftyperesolver = palloc(sizeof(ConflictTypeResolver));
+				conftyperesolver->conflict_type_name = ConflictInfoMap[i].conflict_name;
+				conftyperesolver->conflict_resolver_name = ConflictResolverNames[def_resolver];;
+				res = lappend(res, conftyperesolver);
+			}
+		}
+	}
+
+	return res;
+}
+
+/*
+ * Get the list of conflict types and their corresponding default resolvers.
+ */
+List *
+GetDefaultConflictResolvers()
+{
+	List	   *res = NIL;
+
+	for (ConflictType type = 0; type < CONFLICT_NUM_TYPES; type++)
+	{
+		ConflictTypeResolver *resolver = NULL;
+		ConflictResolver def_resolver = ConflictInfoMap[type].default_resolver;
+
+		/* Allocate memory for each ConflictTypeResolver */
+		resolver = palloc(sizeof(ConflictTypeResolver));
+
+		resolver->conflict_type_name = ConflictInfoMap[type].conflict_name;
+		resolver->conflict_resolver_name = ConflictResolverNames[def_resolver];
+
+		/* Append to the response list */
+		res = lappend(res, resolver);
+	}
+
+	return res;
+}
+
+/*
+ * Update the Subscription's conflict resolvers in pg_subscription_conflict
+ * system catalog for the given conflict types.
+ */
+void
+UpdateSubConflictResolvers(List *conflict_resolvers, Oid subid)
+{
+	Datum		values[Natts_pg_subscription_conflict];
+	bool		nulls[Natts_pg_subscription_conflict];
+	bool		replaces[Natts_pg_subscription_conflict];
+	HeapTuple	oldtup;
+	HeapTuple	newtup = NULL;
+	Relation	pg_subscription_conflict;
+	char	   *cur_conflict_res;
+	Datum		datum;
+
+	/* Prepare to update a tuple */
+	memset(nulls, false, sizeof(nulls));
+	memset(replaces, false, sizeof(replaces));
+	memset(values, 0, sizeof(values));
+
+	pg_subscription_conflict = table_open(SubscriptionConflictId, RowExclusiveLock);
+
+	foreach_ptr(ConflictTypeResolver, conftyperesolver, conflict_resolvers)
+	{
+		/* Set up subid and conflict_type to search in cache */
+		values[Anum_pg_subscription_conflict_confsubid - 1] = ObjectIdGetDatum(subid);
+		values[Anum_pg_subscription_conflict_conftype - 1] =
+			CStringGetTextDatum(conftyperesolver->conflict_type_name);
+
+		oldtup = SearchSysCache2(SUBSCRIPTIONCONFLMAP,
+								 values[Anum_pg_subscription_conflict_confsubid - 1],
+								 values[Anum_pg_subscription_conflict_conftype - 1]);
+
+		if (!HeapTupleIsValid(oldtup))
+			elog(ERROR, "cache lookup failed for table conflict %s for subid %u",
+				 conftyperesolver->conflict_type_name, subid);
+
+		datum = SysCacheGetAttrNotNull(SUBSCRIPTIONCONFLMAP,
+									   oldtup, Anum_pg_subscription_conflict_confres);
+		cur_conflict_res = TextDatumGetCString(datum);
+
+		/*
+		 * Update system catalog only if the new resolver is not same as the
+		 * existing one.
+		 */
+		if (pg_strcasecmp(cur_conflict_res,
+						  conftyperesolver->conflict_resolver_name) != 0)
+		{
+			/* Update the new resolver */
+			values[Anum_pg_subscription_conflict_confres - 1] =
+				CStringGetTextDatum(conftyperesolver->conflict_resolver_name);
+			replaces[Anum_pg_subscription_conflict_confres - 1] = true;
+
+			newtup = heap_modify_tuple(oldtup,
+									   RelationGetDescr(pg_subscription_conflict),
+									   values, nulls, replaces);
+			CatalogTupleUpdate(pg_subscription_conflict,
+							   &oldtup->t_self, newtup);
+			heap_freetuple(newtup);
+		}
+
+		ReleaseSysCache(oldtup);
+	}
+
+	table_close(pg_subscription_conflict, RowExclusiveLock);
+}
+
+/*
+ * Reset the conflict resolver for this conflict type to its default setting.
+ */
+void
+ResetSubConflictResolver(Oid subid, char *conflict_type)
+{
+	ConflictType idx;
+	ConflictTypeResolver *conflictResolver = NULL;
+	List	   *conflictresolver_list = NIL;
+
+	/* Validate the conflict type and get the index */
+	idx = ValidateConflictType(conflict_type);
+	conflictResolver = palloc(sizeof(ConflictTypeResolver));
+	conflictResolver->conflict_type_name = conflict_type;
+
+	/* Get the default resolver for this conflict_type */
+	conflictResolver->conflict_resolver_name =
+		ConflictResolverNames[ConflictInfoMap[idx].default_resolver];
+
+	/* Create a list of conflict resolvers and update in catalog */
+	conflictresolver_list = lappend(conflictresolver_list, conflictResolver);
+	UpdateSubConflictResolvers(conflictresolver_list, subid);
+
+}
+
+/*
+ * Set Conflict Resolvers on the subscription
+ */
+void
+SetSubConflictResolvers(Oid subId, List *conflict_resolvers)
+{
+	Relation	pg_subscription_conflict;
+	Datum		values[Natts_pg_subscription_conflict];
+	bool		nulls[Natts_pg_subscription_conflict];
+	HeapTuple	newtup = NULL;
+	Oid			conflict_oid;
+
+	pg_subscription_conflict = table_open(SubscriptionConflictId, RowExclusiveLock);
+
+	/* Prepare to update a tuple */
+	memset(nulls, false, sizeof(nulls));
+
+	/* Iterate over the list of resolvers */
+	foreach_ptr(ConflictTypeResolver, conftyperesolver, conflict_resolvers)
+	{
+		values[Anum_pg_subscription_conflict_confsubid - 1] =
+			ObjectIdGetDatum(subId);
+		values[Anum_pg_subscription_conflict_conftype - 1] =
+			CStringGetTextDatum(conftyperesolver->conflict_type_name);
+		values[Anum_pg_subscription_conflict_confres - 1] =
+			CStringGetTextDatum(conftyperesolver->conflict_resolver_name);
+
+		/* Get a new oid and update the tuple into catalog */
+		conflict_oid = GetNewOidWithIndex(pg_subscription_conflict,
+										  SubscriptionConflictOidIndexId,
+										  Anum_pg_subscription_conflict_oid);
+		values[Anum_pg_subscription_conflict_oid - 1] =
+			ObjectIdGetDatum(conflict_oid);
+		newtup = heap_form_tuple(RelationGetDescr(pg_subscription_conflict),
+								 values, nulls);
+		CatalogTupleInsert(pg_subscription_conflict, newtup);
+		heap_freetuple(newtup);
+	}
+
+	table_close(pg_subscription_conflict, RowExclusiveLock);
+}
+
+/*
+ * Remove the subscription conflict resolvers for the subscription id
+ */
+void
+RemoveSubConflictResolvers(Oid subid)
+{
+	Relation	rel;
+	HeapTuple	tup;
+	TableScanDesc scan;
+	ScanKeyData skey[1];
+
+	rel = table_open(SubscriptionConflictId, RowExclusiveLock);
+
+	/*
+	 * Search using the subid to return all conflict resolvers for this
+	 * subscription.
+	 */
+	ScanKeyInit(&skey[0],
+				Anum_pg_subscription_conflict_confsubid,
+				BTEqualStrategyNumber,
+				F_OIDEQ,
+				ObjectIdGetDatum(subid));
+
+	scan = table_beginscan_catalog(rel, 1, skey);
+
+	/* Iterate through the tuples and delete them */
+	while (HeapTupleIsValid(tup = heap_getnext(scan, ForwardScanDirection)))
+		CatalogTupleDelete(rel, &tup->t_self);
+
+	table_endscan(scan);
+	table_close(rel, RowExclusiveLock);
+}
diff --git a/src/bin/pg_dump/pg_dump.c b/src/bin/pg_dump/pg_dump.c
index 1b47c38..921b1e5 100644
--- a/src/bin/pg_dump/pg_dump.c
+++ b/src/bin/pg_dump/pg_dump.c
@@ -395,6 +395,8 @@ static void setupDumpWorker(Archive *AH);
 static TableInfo *getRootTableInfo(const TableInfo *tbinfo);
 static bool forcePartitionRootLoad(const TableInfo *tbinfo);
 static void read_dump_filters(const char *filename, DumpOptions *dopt);
+static bool is_default_resolver(const char *confType, const char *confRes);
+static void destroyConcflictResolverList(SimplePtrList *list);
 
 
 int
@@ -4830,7 +4832,9 @@ getSubscriptions(Archive *fout)
 {
 	DumpOptions *dopt = fout->dopt;
 	PQExpBuffer query;
+	PQExpBuffer confQuery;
 	PGresult   *res;
+	PGresult   *confRes;
 	SubscriptionInfo *subinfo;
 	int			i_tableoid;
 	int			i_oid;
@@ -4851,7 +4855,9 @@ getSubscriptions(Archive *fout)
 	int			i_subenabled;
 	int			i_subfailover;
 	int			i,
-				ntups;
+				j,
+				ntups,
+				conf_ntuples;
 
 	if (dopt->no_subscriptions || fout->remoteVersion < 100000)
 		return;
@@ -5012,6 +5018,38 @@ getSubscriptions(Archive *fout)
 		subinfo[i].subfailover =
 			pg_strdup(PQgetvalue(res, i, i_subfailover));
 
+		/* Populate conflict type fields using the new query */
+		confQuery = createPQExpBuffer();
+		appendPQExpBuffer(confQuery,
+						  "SELECT conftype, confres FROM pg_catalog.pg_subscription_conflict "
+						  "WHERE confsubid = %u order by conftype;", subinfo[i].dobj.catId.oid);
+		confRes = ExecuteSqlQuery(fout, confQuery->data, PGRES_TUPLES_OK);
+
+		conf_ntuples = PQntuples(confRes);
+
+		/* Initialize pointers in the list to NULL */
+		subinfo[i].conflict_resolvers = (SimplePtrList)
+		{
+			.head = NULL, .tail = NULL 
+		
+		};
+
+		/* Store conflict types and resolvers from the query result in subinfo */
+		for (j = 0; j < conf_ntuples; j++)
+		{
+			/* Create the ConflictTypeResolver node */
+			ConflictTypeResolver *conftyperesolver = palloc(sizeof(ConflictTypeResolver));
+
+			conftyperesolver->conflict_type = pg_strdup(PQgetvalue(confRes, j, 0));
+			conftyperesolver->resolver = pg_strdup(PQgetvalue(confRes, j, 1));
+
+			/* Append the node to subinfo's list */
+			simple_ptr_list_append(&subinfo[i].conflict_resolvers, conftyperesolver);
+		}
+
+		PQclear(confRes);
+		destroyPQExpBuffer(confQuery);
+
 		/* Decide whether we want to dump it */
 		selectDumpableObject(&(subinfo[i].dobj), fout);
 	}
@@ -5222,7 +5260,43 @@ dumpSubscription(Archive *fout, const SubscriptionInfo *subinfo)
 		appendPQExpBufferStr(publications, fmtId(pubnames[i]));
 	}
 
-	appendPQExpBuffer(query, " PUBLICATION %s WITH (connect = false, slot_name = ", publications->data);
+	appendPQExpBuffer(query, " PUBLICATION %s ", publications->data);
+
+	/* Add conflict resolvers, if any */
+	if (fout->remoteVersion >= 180000)
+	{
+		bool		first_resolver = true;
+		SimplePtrListCell *cell = NULL;
+		ConflictTypeResolver *conftyperesolver = NULL;
+
+		for (cell = subinfo->conflict_resolvers.head; cell; cell = cell->next)
+		{
+			conftyperesolver = (ConflictTypeResolver *) cell->ptr;
+
+			if (!is_default_resolver(conftyperesolver->conflict_type,
+									 conftyperesolver->resolver))
+			{
+				if (first_resolver)
+				{
+					appendPQExpBuffer(query, "CONFLICT RESOLVER (%s = '%s'",
+									  conftyperesolver->conflict_type,
+									  conftyperesolver->resolver);
+					first_resolver = false;
+				}
+				else
+					appendPQExpBuffer(query, ", %s = '%s'",
+									  conftyperesolver->conflict_type,
+									  conftyperesolver->resolver);
+			}
+		}
+
+		/* If there was at least one resolver, close the braces */
+		if (!first_resolver)
+			appendPQExpBufferStr(query, ") ");
+	}
+
+	appendPQExpBuffer(query, "WITH (connect = false, slot_name = ");
+
 	if (subinfo->subslotname)
 		appendStringLiteralAH(query, subinfo->subslotname, fout);
 	else
@@ -5315,6 +5389,9 @@ dumpSubscription(Archive *fout, const SubscriptionInfo *subinfo)
 					 NULL, subinfo->rolname,
 					 subinfo->dobj.catId, 0, subinfo->dobj.dumpId);
 
+	/* Clean-up the conflict_resolver list */
+	destroyConcflictResolverList((SimplePtrList *) &subinfo->conflict_resolvers);
+
 	destroyPQExpBuffer(publications);
 	free(pubnames);
 
@@ -19051,3 +19128,48 @@ read_dump_filters(const char *filename, DumpOptions *dopt)
 
 	filter_free(&fstate);
 }
+
+/*
+ * is_default_resolver - checks if the given resolver is the default for the
+ * specified conflict type.
+ */
+static bool
+is_default_resolver(const char *confType, const char *confRes)
+{
+	/*
+	 * The default resolvers for each conflict type are taken from the
+	 * predefined mapping ConflictTypeDefaultResolvers[] in conflict.c.
+	 *
+	 * Only modify these defaults if the corresponding values in conflict.c
+	 * are changed.
+	 */
+
+	if (strcmp(confType, "insert_exists") == 0 ||
+		strcmp(confType, "update_exists") == 0)
+		return strcmp(confRes, "error") == 0;
+	else if (strcmp(confType, "update_missing") == 0 ||
+			 strcmp(confType, "delete_missing") == 0)
+		return strcmp(confRes, "skip") == 0;
+	else if (strcmp(confType, "update_origin_differs") == 0 ||
+			 strcmp(confType, "delete_origin_differs") == 0)
+		return strcmp(confRes, "apply_remote") == 0;
+
+	return false;
+}
+
+/*
+ * destroyConflictResolverList - frees up the SimplePtrList containing
+ * cells pointing to struct ConflictTypeResolver nodes.
+ */
+static void
+destroyConcflictResolverList(SimplePtrList *conflictlist)
+{
+	SimplePtrListCell *cell = NULL;
+
+	/* Free the list items */
+	for (cell = conflictlist->head; cell; cell = cell->next)
+		pfree((ConflictTypeResolver *) cell->ptr);
+
+	/* Destroy the pointer list */
+	simple_ptr_list_destroy(conflictlist);
+}
diff --git a/src/bin/pg_dump/pg_dump.h b/src/bin/pg_dump/pg_dump.h
index 9f907ed..35a23eb 100644
--- a/src/bin/pg_dump/pg_dump.h
+++ b/src/bin/pg_dump/pg_dump.h
@@ -655,6 +655,13 @@ typedef struct _PublicationSchemaInfo
 /*
  * The SubscriptionInfo struct is used to represent subscription.
  */
+
+typedef struct _ConflictTypeResolver
+{
+	const char *conflict_type;
+	const char *resolver;
+} ConflictTypeResolver;
+
 typedef struct _SubscriptionInfo
 {
 	DumpableObject dobj;
@@ -673,6 +680,7 @@ typedef struct _SubscriptionInfo
 	char	   *suborigin;
 	char	   *suboriginremotelsn;
 	char	   *subfailover;
+	SimplePtrList conflict_resolvers;
 } SubscriptionInfo;
 
 /*
diff --git a/src/bin/pg_dump/t/002_pg_dump.pl b/src/bin/pg_dump/t/002_pg_dump.pl
index ab6c830..ec8b446 100644
--- a/src/bin/pg_dump/t/002_pg_dump.pl
+++ b/src/bin/pg_dump/t/002_pg_dump.pl
@@ -3012,9 +3012,10 @@ my %tests = (
 		create_order => 50,
 		create_sql => 'CREATE SUBSCRIPTION sub3
 						 CONNECTION \'dbname=doesnotexist\' PUBLICATION pub1
+						 CONFLICT RESOLVER (insert_exists = "apply_remote", update_missing = "error")
 						 WITH (connect = false, origin = any);',
 		regexp => qr/^
-			\QCREATE SUBSCRIPTION sub3 CONNECTION 'dbname=doesnotexist' PUBLICATION pub1 WITH (connect = false, slot_name = 'sub3');\E
+			\QCREATE SUBSCRIPTION sub3 CONNECTION 'dbname=doesnotexist' PUBLICATION pub1 CONFLICT RESOLVER (insert_exists = 'apply_remote', update_missing = 'error') WITH (connect = false, slot_name = 'sub3');\E
 			/xm,
 		like => { %full_runs, section_post_data => 1, },
 	},
diff --git a/src/bin/psql/describe.c b/src/bin/psql/describe.c
index 6a36c91..636c507 100644
--- a/src/bin/psql/describe.c
+++ b/src/bin/psql/describe.c
@@ -6545,9 +6545,10 @@ describeSubscriptions(const char *pattern, bool verbose)
 	PQExpBufferData buf;
 	PGresult   *res;
 	printQueryOpt myopt = pset.popt;
+	char	  **footers = NULL;
 	static const bool translate_columns[] = {false, false, false, false,
 		false, false, false, false, false, false, false, false, false, false,
-	false};
+	false, false, false, false, false, false, false};
 
 	if (pset.sversion < 100000)
 	{
@@ -6627,12 +6628,13 @@ describeSubscriptions(const char *pattern, bool verbose)
 			appendPQExpBuffer(&buf,
 							  ", subskiplsn AS \"%s\"\n",
 							  gettext_noop("Skip LSN"));
+
 	}
 
 	/* Only display subscriptions in current database. */
 	appendPQExpBufferStr(&buf,
-						 "FROM pg_catalog.pg_subscription\n"
-						 "WHERE subdbid = (SELECT oid\n"
+						 "FROM pg_catalog.pg_subscription s\n"
+						 "WHERE s.subdbid = (SELECT oid\n"
 						 "                 FROM pg_catalog.pg_database\n"
 						 "                 WHERE datname = pg_catalog.current_database())");
 
@@ -6648,7 +6650,6 @@ describeSubscriptions(const char *pattern, bool verbose)
 	appendPQExpBufferStr(&buf, "ORDER BY 1;");
 
 	res = PSQLexec(buf.data);
-	termPQExpBuffer(&buf);
 	if (!res)
 		return false;
 
@@ -6657,9 +6658,118 @@ describeSubscriptions(const char *pattern, bool verbose)
 	myopt.translate_columns = translate_columns;
 	myopt.n_translate_columns = lengthof(translate_columns);
 
+	if (verbose && pset.sversion >= 180000)
+	{
+		PGresult   *result;
+		int			i,
+					tuples,
+					max_len = 0;
+		char	   *prev_subname = NULL;
+
+		printfPQExpBuffer(&buf,
+						  "SELECT s.subname, c.conftype, c.confres \n"
+						  " FROM pg_catalog.pg_subscription_conflict c \n"
+						  " JOIN pg_catalog.pg_subscription s \n"
+						  " ON c.confsubid = s.oid \n"
+						  " WHERE s.subdbid = (SELECT oid\n"
+						  " FROM pg_catalog.pg_database\n"
+						  " WHERE datname = pg_catalog.current_database())");
+
+		if (!validateSQLNamePattern(&buf, pattern, true, false,
+									NULL, "s.subname", NULL,
+									NULL,
+									NULL, 1))
+		{
+			termPQExpBuffer(&buf);
+			return false;
+		}
+
+		appendPQExpBufferStr(&buf, "ORDER BY s.subname, c.conftype");
+
+		result = PSQLexec(buf.data);
+		if (!result)
+		{
+			termPQExpBuffer(&buf);
+			return false;
+		}
+		else
+			tuples = PQntuples(result);
+
+		/* Calculate the maximum length of the conflict type (conftype) */
+		for (i = 0; i < tuples; i++)
+		{
+			int len = strlen(PQgetvalue(result, i, 1));
+			if (len > max_len)
+				max_len = len;
+		}
+
+		if (tuples > 0)
+		{
+			/*
+			 * Allocate memory for footers. Size of footers will be
+			 * 1 (for storing "Conflict Resolvers" string) + conflict
+			 * resolver count + subscription count + 1 (for storing NULL).
+			 * Subscription count is determined by dividing the number of
+			 * conflict resolvers by 6. This needs to be changed when
+			 * CONFLICT_NUM_RESOLVERS in conflict.h changes
+			 */
+			int subscription_count = tuples / 6;
+			int footer_idx = 1;
+
+			footers = (char **) pg_malloc((1 + tuples + subscription_count + 1)
+										   * sizeof(char *));
+			footers[0] = pg_strdup(_("\nConflict Resolvers:"));
+
+			for (i = 0; i < tuples; i++)
+			{
+				const char *subname = PQgetvalue(result, i, 0);
+				const char *conftype = PQgetvalue(result, i, 1);
+				const char *confres = PQgetvalue(result, i, 2);
+
+				/*
+				 * Print the subscription name only if it changes
+				 * (group by subname).
+				 */
+				if (!prev_subname || strcmp(prev_subname, subname) != 0)
+				{
+					printfPQExpBuffer(&buf, "\n(%s)", subname);
+					footers[footer_idx++] = pg_strdup(buf.data);
+					prev_subname = pg_strdup(subname);
+				}
+
+				/* Adjust the padding to align the "=" */
+				printfPQExpBuffer(&buf, "%s%*s = \"%s\"",
+								  conftype,
+								  (int)(max_len - strlen(conftype) + 2),
+								   "",
+								   confres);
+
+				footers[footer_idx++] = pg_strdup(buf.data);
+			}
+
+			footers[footer_idx] = NULL;
+			myopt.footers = footers;
+		}
+
+		PQclear(result);
+	}
+
 	printQuery(res, &myopt, pset.queryFout, false, pset.logfile);
+	termPQExpBuffer(&buf);
 
 	PQclear(res);
+
+	/* Free the memory allocated for the footer */
+	if (footers)
+	{
+		char	**footer = NULL;
+
+		for (footer = footers; *footer; footer++)
+			pg_free(*footer);
+
+		pg_free(footers);
+	}
+
 	return true;
 }
 
